/*
    2000 Cablemusic Networks, Inc. All rights reserved.
*/

var m_currPreset = -1;
var m_currProgram = -1;
var m_bitrate = 20 ;

var m_bPreset = false ;
var m_programIndex = -1 ;

var m_bCompact = false;

var g_bExpired = false;

var g_setUrl = false;

var g_skinVer = 1.09;

var g_bEfx = true;

var bigWidth = 593;
var bigHeight = 600;
var smallWidth = 475;
var smallHeight = 373;


var myStation ;

var posVar = 404 ;




function SwitchSmall()
{
	
	movePlayButton();
	
	
	
	video.visible = false;
	posVar = 175 ;
	moveSetDrawer();
	mainPlayer.visible = false ;
	screen.visible = false ;
	subPrograms.visible = false ;
	subPresets.visible = false ;
	subPlayList.visible = false ;
	view.width = smallWidth;
	view.height = smallHeight;
	modeShuffle.visible=false;
	
	smallPlayer.visible = true ;
	
	
	disablePresetMode();

	m_bCompact = true;

	SetPresetTooltip();
	SetBitrateBtn();
	
	LayoutEffects();

	LayoutProgramInfo();
	
	SetPresetState();
	
	if(player.playState == psPlaying)
	{
	UpdateProgramInfo();
	}

	return ;
	
    view.width = bigSkin ? bigWidth : smallWidth;
    view.height = bigSkin ? bigHeight : smallHeight;
    smallPlayer.visible = !bigskin;
    mainPlayer.visible = bigSkin;
}


function SwitchBig()
{
	posVar = 404 ;
	
	
	if(m_bCompact == true)
	{
	moveSetDrawer();
	movePlayButton();
	}
	
	smallPlayer.visible = false ;
	mainPlayer.visible = true ;
	screen.visible = true ;
	subPrograms.visible = true ;
	subPresets.visible = true ;
	subPlayList.visible = true ;
	view.width = bigWidth;
	view.height = bigHeight;
	video.visible = true;
	modeShuffle.visible=true;
	
	
	
	m_bCompact = false;

	SetPresetTooltip();
	SetBitrateBtn();
	LayoutEffects();
	
	LayoutProgramInfo();

	SetPresetState();
	
	
	if(player.playState == psPlaying)
	{
	UpdateProgramInfo();
	}
	
	
	
	//showAttributes();

}

function movePlayButton()
{		
	if(buttonsView.top == 344)
		buttonsView.moveTo(buttonsView.left,116,0);
	else 
		buttonsView.moveTo(buttonsView.left,344,0);
}


function moveSetDrawer()
{		
	if(setDrawer.top == posVar)
		setDrawer.moveTo(setDrawer.left,posVar + 73,200);
	else 
		setDrawer.moveTo(setDrawer.left,posVar,200);
}

function CStation(programName, description, suffix64, suffix20)
{
	this.programName = programName ;
	this.description = description ;
	this.suffix64 = suffix64 ;
	this.suffix20 = suffix20 ;
}

var stations = new Array() ;

// Default 7 stations
stations[stations.length] = new CStation('Country', 'Country', 'country_64k.asx', 'CountryU') ;
stations[stations.length] = new CStation('ClassicRock', 'Classic Rock', 'station3_64k.asx', 'ClassicRockU') ;
stations[stations.length] = new CStation('MainstreamRock', 'Mainstream Rock', 'mainstreamrock_64k.asx', 'MainstreamRock/MainstreamRockPU.asx') ;
stations[stations.length] = new CStation("ModernRock","Modern Rock", "modernrock_64k.asx", 'modernRockU') ;
stations[stations.length] = new CStation('Top40', 'Top 40', 'top40_64k.asx', 'Top40U') ;
stations[stations.length] = new CStation("SmoothJazz", "Smooth Jazz", "station5_64k.asx", 'SmoothJazzU') ;
stations[stations.length] = new CStation('Trance', 'Trance', 'station7_64k.asx', 'TranceU') ;

stations[stations.length] = new CStation('Top40RB', 'Top 40 R&B', 'top40rb_64k.asx', 'Top40RBU') ;
stations[stations.length] = new CStation('AlternativeRock', 'Alternative Rock', 'station1_64k.asx', 'AlternativeRockU' ) ;
stations[stations.length] = new CStation('Classical','Classical', "station2_64k.asx", 'ClassicalU') ;
stations[stations.length] = new CStation('Hot100','Hot 100', "hot100_64k.asx", 'Hot100U') ;
stations[stations.length] = new CStation('House', 'House', 'station6_64k.asx', 'HouseU') ;
stations[stations.length] = new CStation('NewWave80s', 'New Wave 80\'s', 'station4_64k.asx', 'NewWave80sU') ;
stations[stations.length] = new CStation('Top40Adult', 'Top 40 Adult', 'top40adult_64k.asx', 'Top40AdultU') ;
stations[stations.length] = new CStation('CoolJazz', 'Cool Jazz', 'station9_64k.asx', 'CoolJazzU') ;
stations[stations.length] = new CStation('Jungle', 'Drum & Bass / Jungle', 'station8_64k.asx', 'JungleU') ;
stations[stations.length] = new CStation('FoundationX', 'FoundatioN-X', 'station10_64k.asx', 'FoundationXU') ;

var sMap = new Array() ;

function findStation(name)
{
	var i;
	var n = stations.length;
	for(i=0;i<n;i++)
		if(stations[i].programName == name)
			return i;
			
	return -1;
}

function disablePresetMode()
{
	m_bPreset = false ;
	m_programIndex = -1 ;
	t1.value = '' ;
	SetPresetTooltip();
}

function updateZ()
{
	if (subPresets.left!=178)
	{
		subPresets.zIndex=-3 ;
		subPrograms.zIndex=-2 ;
		subPlayList.zIndex=-2 ;
	}
	else if (subPrograms.left!=178)
	{
		subPresets.zIndex=-2 ;
		subPrograms.zIndex=-3 ;
		subPlayList.zIndex=-2 ;
	}
	else
	{
		subPresets.zIndex=-2 ;
		subPrograms.zIndex=-2 ;
		subPlayList.zIndex=-3 ;
	}
}

function PresetSViewMove()
{
	if(subPrograms.left==363)
		ProgramsSViewMove() ;
	if(subPlayList.left==373)
		PlayListMove() ;

	subPresets.moveTo((subPresets.left==178) ? 364 : 178 ,subPresets.top,400) ;
	
	disablePresetMode() ;

}

function ProgramsSViewMove()
{
	if(subPresets.left==364)
		PresetSViewMove() ;
	if(subPlayList.left==373)
		PlayListMove() ;

	subPrograms.moveTo((subPrograms.left==178) ? 363 : 178 ,subPrograms.top,400) ;
	
}

function PlayListMove()
{
	if(subPrograms.left==363)
		ProgramsSViewMove() ;
	if(subPresets.left==364)
		PresetSViewMove() ;
	
	subPlayList.moveTo((subPlayList.left==178) ? 373 : 178 ,subPlayList.top,400) ;

}


function StartProgram()
{
	var id = String(event.srcElement.id);
	var i = Number(id.substring(2));
	HandleStop();
	PlayThis(i);
	
}

function EjectCd()
{
	player.cdromcollection.item(0).eject();
}

function HandleCDStart()
{
	m_currPreset = -1;
	m_currProgram = -1;
	SetPresetsDown(false);
	ResetProgramInfo();
}



function HandleStop()
{
	m_currPreset = -1;
	m_currProgram = -1;
	player.controls.stop() ;
	SetPresetsDown(false);
	
	ResetProgramInfo();
}

function pbtnName()
{
	return (m_bCompact ? 'cnpb' : 'bnpb');

}

function SetAssignTooltip(description)
{
	var i;
	for(i=0;i<7;i++)
	{
		var id = pbtnName() + i;
		
		var msg = 'Click To Set: ' + description + ' (' +
				  'Current: ' + stations[sMap[i]].description + ')';

		setAttr(id, "upToolTip", msg, true);
		setAttr(id, "downToolTip", msg, true);
	}
}

function SetPresetTooltip()
{
	var i;
	for(i=0;i<7;i++)
	{
		var id = pbtnName() + i;
		
		setAttr(id, "upToolTip", stations[sMap[i]].description, true);
		//var ex = id + '.upToolTip="' + stations[sMap[i]].description + '";';
		//eval(ex);
		//theme.logString(ex);

		setAttr(id, "downToolTip", stations[sMap[i]].description, true);
	}
}

function AssignPreset()
{
	var id = String(event.srcElement.id);
	var i = Number(id.substring(2));

	m_bPreset = true ;
	m_programIndex = i ;
	
	t1.value = 'Click a preset button for: ' + stations[i].description ;

	//var ex = id + '.upToolTip="Click To Set Preset ' + stations[i].description + '";';
	//eval(ex);
	
	SetAssignTooltip(stations[i].description);
}

function setAttr(id,attr,val,bQuote,to)
{
	var ex = id + '.' + attr + ' = ' ;
	if(bQuote)
		ex += '"';
	ex += String(val);
	if(bQuote)
		ex += '"';
	ex += ';';
	
	//theme.logString(ex);
	if(to)
		setTimeout(ex,to);
	else
		eval(ex);
	
}

function SetPresetDown(i,bDown)
{
	var id = pbtnName() + i;
	setAttr(id,"down",bDown);
}

function SetPresetsDown(bDown)
{
	var i;
	for(i=0;i<7;i++)
	{
		SetPresetDown(i, bDown);
	}	
}

function SetPresetState()
{
	SetPresetsDown(false);
	if(m_currPreset != -1)
		SetPresetDown(m_currPreset,true);
}

function ClickPreset(i)
{
	var id = pbtnName() + i;
	

	if (m_bPreset && m_programIndex != -1)
	{
		if(m_currPreset == i)
			HandleStop();
		
		m_bPreset = false ;
		sMap[i] = m_programIndex ;
		SetPresetTooltip();
		t1.value = '' ;
		m_programIndex = -1;
		
		SetPresetDown(i,false);
	}
	else
	{
		HandleStop();
		
		SetPresetsDown(false);
		SetPresetDown(i,true);

		//theme.logString('ClickPreset ' + id);
		//t1.value = sMap[i] ;
		m_currPreset = 	i;
		PlayThis(sMap[i]) ;
	}
		
}

var psUndefined = 0;
var psStopped = 1;
var psPaused = 2;
var psPlaying = 3;
var psScanForward = 4;
var psScanReverse = 5;
var psBuffering = 6;
var psWaiting = 7;
var psMediaEnded = 8;
var psTransitioning = 9;
var psReady = 10;

var g_author = null;
var g_title = null;
var g_copy = null;

var g_toExp = null;


function handleTimer()
{
	if(g_toExp != null)
	{
		eval(g_toExp);
		g_toExp = null;
		mainview.timerInterval = 60000;
//		mainPlayer.timerInterval = 60000;
	}
	else
		heartbeat();
}

function heartbeat()
{
	UpdateBitrate();
	ShowAdBanner();
}

function setTimeout(exp, msec)
{
	g_toExp = exp;
	mainview.timerInterval = msec;
//	mainPlayer.timerInterval = msec;
}

function handleScriptCommand(scType,Param)
{
	//theme.logString('handleScriptCommand ' + scType + ' ' + Param);
	
	if(scType == "AUTHOR")
		g_author = Param;
	else if(scType == "TITLE")
		g_title = Param;
	else if(scType == "COPYRIGHT")
		g_copy = Param;
		
	if(g_author != null || g_title != null || g_copy != null)
		UpdateProgramInfo();
}

var g_buffProg = false;

function handleBuffering(Start)
{
	//theme.logString('handleBuffering ' + Start);
	
	if(Start)
	{
		g_buffProg = true;
		setTimeout('showBuffProg()',50);
	}
	else
	{
		g_buffProg = false;
		txtBuff.value = "";
		UpdateBitrate();
	}
		
}

function showBuffProg()
{
	//theme.logString('showBuffProg');
	
	if(g_buffProg)
	{
		//var msg = 'Buffering ' + player.network.bufferingProgress + '%' ;
		
		var msg = 'Buffering...';
		
		//theme.logString(msg);
		txtScroll.value = "";
		txtBuff2.value = msg;
		txtBuff.value = msg;
		setTimeout('showBuffProg()',100);
	}
	else
	{
		txtBuff2.value = "";
		txtBuff.value = "";
		UpdateBitrate();
	}
}


function handlePlayStateChange()
{
	//theme.logString('handlePlayStateChange ' + player.playState);
	
	if(player.playState == psPlaying)
	{
		handleBuffering(false);
		UpdateProgramInfo();
		LayoutEffects();
	}
	else if(player.playState == psBuffering)
	{
		handleBuffering(true);
	}
}

function LayoutEffects()
{
	var b = isEfx();
	
	if(m_bCompact)
	{
		vwEffects.top = 95;
		vwEffects.left = 5;
		vwEffects.width = 361;
		vwEffects.height = 57;
		
		theEffects.width = 362;
		theEffects.height = 57;
		
	}
	else
	{
		vwEffects.top = 95;
		vwEffects.left = 8;
		vwEffects.width = 360;
		vwEffects.height = 245;
		
		theEffects.width = 360;
		theEffects.height = 245;
		
	}
	
	theEffects.visible = b;
	theEffects.enabled = b;
}


function nextEffect()
{
	if(!isEfx()) return;
	theEffects.next(); 
	g_effName=theEffects.currentEffectType;
	//t1.value = g_effName;
	//theme.logString(theEffects.currentEffectTitle);
}

function previousEffect()
{
	if(!isEfx()) return;

	theEffects.previous(); 
	g_effName=theEffects.currentEffectType;
	//t1.value = g_effName;

}

function PlayThis(index) 
{
	txtScroll.value = "";
	txtBuff2.value = "Starting...";
	txtBuff.value = "Starting...";
	
	m_currProgram = index ;
	
	//var ex = 'stations[index].suffix' + m_bitrate ;
	//player.url= eval('baseURL' + m_bitrate) + eval(ex) ; 
	
	var programName = stations[index].programName;
	
	var url = 'http://www.cablemusic.com/stations/genASX.asp';
	url += '?program=' + escape(programName);
	url += '&bitrate=' + m_bitrate;
	
	//theme.logString(url);
	
	g_setUrl = false;
	
	player.url = url;
	
	enableEffects(isEfx());
	

}

function SetBitrate(x)
{
	if (m_bitrate == x) 
		return ;
		
	m_bitrate = x ;
	
	SetBitrateBtn();

	var i = m_currPreset;
	var j = m_currProgram;

	if(j != -1)
		HandleStop();
	
	if(i != -1)
		ClickPreset(i);
	else if(j != -1)
		PlayThis(j);

// t1.value = m_bitrate ;	
}

function SetBitrateBtn()
{
	if(!m_bCompact)
	
	{
		btn64k.down = (m_bitrate == 64);
		btn20k.down = (m_bitrate == 20);
	}
}


var plfalse = false ;
var pltrue = true ;

function HidePlist()
{
	if(subPlayList.left == 373)
	{
		pl.visible = plfalse
	}
	
}
		
function PlOnEndMove()
{
	if(subPlayList.left == 373)
   	{
 	pl.visible = pltrue 
	}
}


var g_tBan = new Date();
var g_banDelay=60000;

function ShowAdBanner()
{
	return;
	var b = false;
	var d = new Date();
	
	if(g_tBan == null)
	{
		g_tBan = new Date();
		b = true;
	}
	else
	{
		var diff = d.getTime() - g_tBan.getTime();
		
		b = (diff >= g_banDelay);
	}
	
	if(b)
	{
		g_tBan = d;
		var url = 'http://www.cablemusic.com/audioAds/cmcAd3.asp';
		if(g_bExpired)
			url += '?expired=1';
		player.launchURL(url);
		
		g_banDelay = 300000;
	}
}

function UpdateBitrate()
{
	if(player.playState != psPlaying)
	{
		txtBit.value = '';
		return;
	}

	var bitrate = player.network.bitRate;
	
	//theme.logString('UpdateBitrate ' + bitrate);
	
	if(m_bCompact)
		txtBit.value = '';
	else
		txtBit.value = bitrate + ' bps';
}


function ResetProgramInfo()
{
	//theme.logString("ResetProgramInfo");

	g_author = null;
	g_title = null;
	g_copy = null;
	
	if(m_bCompact)
	{
		txtScroll.scrolling = false;
		txtScroll.value = "";
		txtBuff2.value = "";
	}
	else
	{
		txtShow.value = "";
		txtClip.value = "";
		txtAuthor.value = "";
		txtCopy.value = "";
	
		txtBuff.value = "";
		txtBit.value = "";
	}
	
	ad.image='';
	ad.visible = false;
	adBorder.visible = false;
	
}

function setBannerUrl()
{
	ad.image='WMPImage_AdBanner';
	ad.visible = true;
	adBorder.visible = true;
	if(!g_setUrl)
	{
		player.currentMedia.setItemInfo('BannerInfoURL',"http://adforce.imgis.com/?adlink|2.0|87|102306|1|1|misc=cmc100;loc=500;");
		g_setUrl = true;
	}
}

function PlayListStart()
{
	m_currProgram == -1;
}

function UpdateProgramInfo()
{
	
	CheckVersion();
	checkRadioUrl();
	checkEffect();	
	
	if(m_bCompact)
		GenericProgramInfoSmall();
	else
		GenericProgramInfoBig();
		
	
}

function onBuy()
{
	var cm = player.currentMedia;
	var pullString = player.currentMedia.sourceURL;
	var bNetUrl = pullString.indexOf('http') != -1 || pullString.indexOf('mms') != -1;
	var bCmcUrl = pullString.indexOf('cablemusic.com') != -1;
	
	var title;
	
	if(bNetUrl)
		title = (g_title != null && (m_currProgram != -1 || bCmcUrl) && bNetUrl ? g_title : cm.getItemInfo('title'));
	else
		title = cm.name;
		
	if(title == null) return;
	
	if(title.length == 0) return;

	var url = 'http://www.cablemusic.com/cmcPlayer/buy.asp?song=' + escape(title);
	player.launchUrl(url);
}

function GenericProgramInfoBig()
{
	txtScroll.visible = false;

	
	var cm = player.currentMedia;

	var pullString = player.currentMedia.sourceURL;
	//var oneChar = pullString.substring(6,12);
	//if(oneChar == "media2")
	
	var bNetUrl = pullString.indexOf('http') != -1 || pullString.indexOf('mms') != -1;
	var bCmcUrl = pullString.indexOf('cablemusic.com') != -1;
	
	//theme.logString(pullString);
	
	var author, title, copy;
	
	if(bNetUrl)
	{
		author = (g_author != null  && (m_currProgram != -1 || bCmcUrl) && bNetUrl ? g_author : cm.getItemInfo('author'));
		title = (g_title != null && (m_currProgram != -1 || bCmcUrl) && bNetUrl ? g_title : cm.getItemInfo('title'));
		copy = (g_copy != null && (m_currProgram != -1 || bCmcUrl) && bNetUrl ? g_copy : cm.getItemInfo('copyright'));
	}
	else
	{
		HandleCDStart();
		
		author = cm.getItemInfo('author');
		title = cm.name;
		copy = cm.getItemInfo('copyright');
	}

	txtShow.value = player.currentplaylist.name;
	txtClip.value = title;
	txtAuthor.value = author;
	txtCopy.value = copy;	
	
	if(bNetUrl && m_currProgram != -1)	
	{	
		setBannerUrl();	
	}
	else 
	{
		ad.visible = false;
		adBorder.visible = false;
		SetPresetsDown(false);
	}
	
}

function GenericProgramInfoSmall()
{
	txtScroll.visible = true;
	
	var show = player.currentplaylist.name;
	var cm = player.currentMedia;
	
	var pullString = player.currentMedia.sourceURL;
	//var oneChar = pullString.substring(6,12);
	//if(oneChar == "media2")
	
	var bNetUrl = pullString.indexOf('http') != -1 || pullString.indexOf('mms') != -1;

	var author, title, copy;
	
	if(bNetUrl)
	{
		author = (g_author != null  && m_currProgram != -1 && bNetUrl ? g_author : cm.getItemInfo('author'));
		title = (g_title != null && m_currProgram != -1 && bNetUrl ? g_title : cm.getItemInfo('title'));
		copy = (g_copy != null && m_currProgram != -1 && bNetUrl ? g_copy : cm.getItemInfo('copyright'));
	}
	else
	{
		HandleCDStart();
		author = cm.getItemInfo('author');
		title = cm.name;
		copy = cm.getItemInfo('copyright');
	}
	
	author += ' -- ';
	author += show;
	author += ' -- ';
	author += title;
	author += ' -- ';
	author += copy;
	author += ' -- ';
	
	txtBuff2.value = "";
	txtScroll.value = author;
	txtScroll.scrolling = true;
	
	
	if(bNetUrl && m_currProgram != -1)	
	{	
		setBannerUrl();	
	}else 
	{
		ad.visible = false;
		adBorder.visible = false;
		SetPresetsDown(false);
	}
	
}

function LayoutProgramInfo()
{
	if(m_bCompact)
		LayoutProgramInfoCompact();
	else
		LayoutProgramInfoExpanded();
}

function LayoutProgramInfoCompact()
{
	txtScroll.top = 165;
	txtScroll.left = 45;
	txtScroll.width = 281;
	txtScroll.fontSize = 8;
	txtScroll.justification = "left";
	txtScroll.value = '';
	
	txtBuff2.top = 165;
	txtBuff2.left = 45;
	txtBuff2.width = 100;
	txtBuff2.fontSize = 8;
	txtBuff2.justification = "left";
	txtBuff2.value = '';

}

function LayoutProgramInfoExpanded()
{
	var fsize = 7;
	
	var ybase = 350;
	var xbase = 50;
	
	var y = ybase;
	var x = xbase;
	
	var yoff = 12;
	var lw = 55;
	var xs = 4;
	
	txtShowLabel.top = y;
	txtShowLabel.left = x;
	txtShowLabel.width = lw;
	txtShowLabel.fontSize = fsize;
	txtShowLabel.justification = "right";
	txtShowLabel.value = 'Show: ';
	
	y += yoff;
	txtClipLabel.top = y;
	txtClipLabel.left = x;
	txtClipLabel.width = lw;
	txtClipLabel.fontSize = fsize;
	txtClipLabel.justification = "right";
	txtClipLabel.value = 'Clip: ';

	y += yoff;
	txtAuthorLabel.top = y;
	txtAuthorLabel.left = x;
	txtAuthorLabel.width = lw;
	txtAuthorLabel.fontSize = fsize;
	txtAuthorLabel.justification = "right";
	txtAuthorLabel.value = 'Author: ';

	y += yoff;
	txtCopyLabel.top = y;
	txtCopyLabel.left = x;
	txtCopyLabel.width = lw;
	txtCopyLabel.fontSize = fsize;
	txtCopyLabel.justification = "right";
	txtCopyLabel.value = 'Copyright: ';
	
	y += yoff;
	txtBuff.top = y;
	txtBuff.left = x;
	txtBuff.width = "100";
	txtBuff.fontSize = fsize;
	txtBuff.justification = "left";
	txtBuff.value = '';

	txtBit.top = y;
	txtBit.left = x + 230;
	txtBit.width = "100";
	txtBit.fontSize = fsize;
	txtBit.justification = "left";
	txtBit.value = '';

	var w = 230;
	
	y = txtShowLabel.top;
	x = txtShowLabel.left + lw + xs;
	txtShow.top = y;
	txtShow.left = x;
	txtShow.width = w;
	txtShow.fontSize = fsize;
	txtShow.justification = "left";
	txtShow.value = '';
	
	y = txtClipLabel.top;
	x = txtClipLabel.left + lw + xs;
	txtClip.top = y;
	txtClip.left = x;
	txtClip.width = w;
	txtClip.fontSize = fsize;
	txtClip.justification = "left";
	txtClip.value = '';
	
	y = txtAuthorLabel.top;
	x = txtAuthorLabel.left + lw + xs;
	txtAuthor.top = y;
	txtAuthor.left = x;
	txtAuthor.width = w;
	txtAuthor.fontSize = fsize;
	txtAuthor.justification = "left";
	txtAuthor.value = '';
	
	y = txtCopyLabel.top;
	x = txtCopyLabel.left + lw + xs;
	txtCopy.top = y;
	txtCopy.left = x;
	txtCopy.width = w;
	txtCopy.fontSize = fsize;
	txtCopy.justification = "left";
	txtCopy.value = '';
	
}


function InitPrograms(nmbase, tip)
{
	var i;
	var n = stations.length;
	
	var top = 30;
	var left = 40;
	
	//theme.logString('InitPrograms');
	
	for(i=0;i<n;i++)
	{
		var nm = nmbase + i;
		
		var ex = nm + '.value = "' + stations[i].description + '";';
		eval(ex);

		setAttr(nm, 'toolTip', tip, true) ;
		
		//ex = nm + '.onmousedown = "Preset(' + i + ');";';
		//eval(ex);
		//theme.logString(ex);
		
		ex = nm + '.top = "' + top + '";';
		eval(ex);

		ex = nm + '.left = "' + left + '";';
		eval(ex);

		ex = nm + '.cursor = "hand";';
		eval(ex);

		ex = nm + '.width = 200 ;';
		eval(ex);

		top += 15;
		
	}
}

function InitPresets()
{
	var i ;

	for ( i=0; i<7; i++)
	{
		var nm = 'npb' + i ;
		var temp = theme.loadPreference(nm); 
		
		//theme.logString(temp);

		if (temp != '--') 
			sMap[i] = Number(temp) ;
		else
			sMap[i] = i ;

		//var ex = nm + ".upToolTip=stations[sMap[" + i + "]].description" ;
		//eval(ex) ;
		
	}
	
	SetPresetTooltip();	

}

var g_effName = 'Plenoptic';

function initEffects()
{
	var temp = theme.loadPreference('efx'); 
	if (temp != '--') 
		g_effName = temp ;
	else
		g_effName = 'Plenoptic' ;
		
	theEffects.currentEffectType = g_effName;
	
	enableEffects(true);
	
	//theme.logString(temp);
}

function CheckVersion()
{
	var v = getAttrInt('cmcSkinVersion');
	if(v == -1) return;
	
	if(v > g_skinVer)
	{
		player.launchURL('http://www.cablemusic.com/skins/install.asp?update=1');
	}

	/*var key = 'cmcVerDate';
	var d = new Date();
	var cmcVerDate = theme.loadPreference(key);
	if(cmcVerDate == '--')
	{
		theme.savePreference(key, d.toUTCString());
		return ;
	}
	dver = new Date(Date.parse(cmcVerDate));
	var diff = d.getTime() - dver.getTime();
	var maxAge = 2 * 7 * 24 * 3600 * 1000;
	if(diff > maxAge)
	{
		g_bExpired = true;
		player.launchURL('http://www.cablemusic.com/skins/updateSkin.asp');
	}*/
}

function InitQuality()
{

	var bitrate = 20;
	
	t1.value = 'InitQuality';
	
	try
	{
		bitrate = Number(player.currentMedia.getItemInfo('bitrate'));
	}
	catch(e)
	{
		bitrate = 20;
	}
	
	t1.value = 'bitrate: ' + bitrate;
	
	if(bitrate != 20 && bitrate != 64)
		bitrate = 20;
	
	m_bitrate = bitrate;
	
	//theme.logString(bitrate);
	
	SetBitrateBtn();

	t1.value = 'End InitQuality';
}

var g_checkEffect = false;

function checkEffect()
{
	if(g_checkEffect) return;
	
	g_checkEffect = true;
	
	if(g_effName.toLowerCase() == 'plenoptic')
	{
		theEffects.next();
		theEffects.next();
		theEffects.next();
	}
}

function checkRadioUrl()
{
	var nRadioUrl = getAttrInt('cmcRadio');
	if(nRadioUrl != 1) return;
	
	SetPresetsDown(false);
	m_currPreset = -1;

	var startProgram = getAttrString('cmcProgramName');
	if(startProgram == "") 
		m_currProgram = -1;
	else
	{
		if(m_currProgram != -1 && stations[m_currProgram].programName != startProgram)
		{
			ResetProgramInfo();
			var i = findStation(startProgram);
			m_currProgram = i;
			UpdateProgramInfo();
		}
	}
	
	var bitrate = getAttrInt('cmcBitrate');
	if(bitrate != m_bitrate)
	{
		m_bitrate = bitrate;
		SetBitrateBtn();
	}
}

function getAttrInt(name)
{
	var s;
	try
	{
		s = String(player.currentMedia.getItemInfo(name));		
	}
	catch(e)
	{
		s = "-1";
	}
	
	//t1.value = s + '(' + s.length;
	
	if(s == 'undefined' || s == '')
		s = '-1';
	
	return Number(s);
}

function getAttrString(name)
{
	var s = "";
	try
	{
		s = String(player.currentMedia.getItemInfo(name));		
	}
	catch(e)
	{
		s = "";
	}
	
	if(s == 'undefined')
		s = "";
	
	return s;
}

function showAttributes()
{
	var i;
	var n = player.currentMedia.AttributeCount;
	t1.value = 'Attribute List ' + n + '\r\n';
	var s = '';
	for(i=0;i<n;i++)
	{
		try {
		s = player.currentMedia.getAttributeName(i) + '\r\n';
		t1.value += s;
		}
		catch(e)
		{
		}
	}
	
	s = 'Playlist Name: ' + player.currentPlaylist.Name + '\r\n';
	t1.value += s;

}

function Init()
{
	LayoutProgramInfo();
	LayoutEffects();
	
	player.Settings.invokeURLs = false;
	
	InitPresets(pbtnName()) ;
	InitPrograms('pr', 'Click to listen') ;
	InitPrograms('ps', 'Click to assign preset') ;
	
	//InitQuality();
	
	SetBitrateBtn();

	initEffects() ;
	
	//t1.value = g_skinVer;
	
}

function SavePresets()
{
	var i ;
	for ( i=0; i<7; i++)
	{
		var nm = 'npb' + i ;
		theme.savePreference(nm, sMap[i]) ;
	}
}

function saveEffect()
{
	theme.savePreference('efx', g_effName) ;	
}

function Save()
{
	SavePresets();
	saveEffect() ;
}


function resetEQ() 
{
	eq1.value=-1;
	eq2.value=-1;
	eq3.value=-1;
	eq4.value=-1;
	eq5.value=-1;
	eq6.value=-1;
	eq7.value=-1;
	eq8.value=-1;
	eq9.value=-1;
	eq10.value=-1;	
}

function isEfx()
{
	return g_bEfx;
}

function toggleEfx()
{
	enableEffects(!isEfx());
}

function enableEffects(bEnable)
{
	g_bEfx = bEnable;
	//vwEffects.visible = bEnable;
	theEffects.visible = bEnable;
	theEffects.enabled = bEnable;
}

var g_bWasEfx=false;
function StartVideo()
{
	g_bWasEfx = isEfx();
	enableEffects(false);
}

function EndVideo()
{
	enableEffects(g_bWasEfx);
}





// Collapsed view


